shuoj1019-Prime Path--bfs

2 篇文章 0 订阅

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6

7

0


链接::Prime Path

题意::从n换到m,每次换n中的一位,每一次换后都为质数,求最少换的次数。

题解::明显的本题需要使搜索,dfs或bfs。dfs也想了很久没有解答出来。bfs本身就可以求最短路径,适合本题求解。

bfs大致步骤::

queue<temp> Q;

Q.push(a[1]);

while(!Q.empty())

{

int x = Q.front();Q.pop();

if()...;

for(...)

{

Q.push(...);

}

代码::

#include<bits/stdc++.h>
using namespace std;
#define XINF INT_MAX
#define INF 0x3FFFFFFF
#define MP(X,Y) make_pair(X,Y)
#define PB(X) push_back(X)
#define REP(X,N) for(int X=0;X<N;X++)
#define REP2(X,L,R) for(int X=L;X<=R;X++)
#define DEP(X,R,L) for(int X=R;X>=L;X--)
#define CLR(A,X) memset(A,X,sizeof(A))
#define IT iterator
#define LOCAL
typedef long long ll;
typedef pair<int,int> PII;
typedef vector<PII> VII;
typedef vector<int> VI;
//const int MAXN = 10010;

//判断素数
bool sushu(int x){
    for(int i = 2;i*i<=x;i++)
        if(x%i==0) return 0;
    return 1;
}
int vis[10000];//判断是否加入过队列
int cnt[10000];//cnt[i]记录从n到i的操作次数。。。。为本题关键
int main(){
    /*
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #endif */
    int T;
    cin>>T;
    while(T--){
        int n,m;
        cin>>n>>m;
        memset(vis ,0 ,sizeof(vis));
        memset(cnt ,0 ,sizeof(cnt));
        queue<int> Q;
        Q.push(n);
        while(!Q.empty()){
            int temp = Q.front();Q.pop();
            vis[temp] = 1;
            if(temp == m)break;//当找到temp == m是即可退出循环
            int i = 0;
            int  x = temp;
            int a[5];//记录temp的各个位数大小
            while(temp){
                a[i++] = temp%10;
                temp/=10;
            }
            REP(i,10){
                REP(j,4){
                    if(j==3&&i==0)continue;//千位为零时不进行运算
                    if(j==0) temp = i+a[1]*10+a[2]*100+a[3]*1000;//个位换
                    if(j==1)temp = a[0]+i*10+a[2]*100+a[3]*1000;//十位
                    if(j==2)temp = a[0]+a[1]*10+i*100+a[3]*1000;//百位
                    if(j==3)temp = a[0]+a[1]*10+a[2]*100+i*1000;//千位
                    if(vis[temp] == 0&&sushu(temp) == 1)
                        {
                            vis[temp] = 1;
                            cnt[temp] = cnt[x]+1;//从前一个数变到现在的数操作次数加一
                            Q.push(temp);
                    }
                }
            }
        }
        if(cnt[m]>0||n == m)
        cout<<cnt[m]<<endl;//输出从n到m的操作次数
        else cout<<"Impossible"<<endl;
    }

   //printf("Time used = %.2lf\n",(double)clock()/CLOCKS_PER_SEC);

}
欢迎dfs解法

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值